function [ Z_Scores , LTM_Data , LTM_STD , Base_Date , Observation] = Computing_Standard_Scores_97_12_09(Data , Date , Calendar )
%% Computing Standard Scores Of Each Stations....
% Calendar 1 means Solar Persian Calendar...
% Calendar 0 means Gregorian      Calendar...
if Calendar==1;
    LTM_Data = []; LTM_STD = []; base_date = []; Obs = []; 
    for month = 1:12
        for day = 1:31
            Cxa = Date( : , 2 )==month & Date( : , 3)==day;
            if sum(Cxa)>0; LTM_Data = [ LTM_Data ;  nanmean( Data( Cxa , : ))];
                LTM_STD = [ LTM_STD ;  nanstd( Data( Cxa , : ))];
                Obs = [  Obs ; sum(~isnan(Data( Cxa , : ))) ];
                base_date = [ base_date ; month , day ]; end
        end
    end
    Aa = ((LTM_Data( 1 , : )+LTM_Data( 365 , : ))./2);  LTM_Data( 366 , : ) = Aa;  LTM_Data(isinf(LTM_Data)) = nan;
    Ab = ((LTM_STD( 1 , : )+LTM_STD( 365 , : ))./2);   LTM_STD( 366 , : ) = Ab;  LTM_STD(isinf(LTM_STD))  = nan;
end;
%%
if  Calendar==0;  
    LTM_Data = []; LTM_STD = []; base_date = [];
    for month = 1:12
        for day = 1:31
            Cxa = Date( : , 5 )==month & Date( : , 6)==day;
            if sum(Cxa)>0; LTM_Data = [ LTM_Data ;  nanmean( Data( Cxa , : ))];
                LTM_STD = [ LTM_STD ;  nanstd( Data( Cxa , : ))];
                base_date = [ base_date ; month , day ];
                        
            end
        end
    end
    Aa = ((LTM_Data( 59 , : )+LTM_Data( 61 , : ))./2); LTM_Data( 60 , : ) = Aa;   LTM_Data(isinf(LTM_Data)) = nan;
    Ab = ((LTM_STD( 59 , : )+LTM_STD( 61 , : ))./2);  LTM_STD( 60 , : )  = Ab;   LTM_STD(isinf(LTM_STD)) = nan;
end;
%% Subsituting Missing Values(NaNs) With Mean Climatology....
% for j = 1:size( Data , 1 )
%     vv = find(isnan(Data( j , : )));
%     if ~isempty(vv)
%         Cxa = base_date( : , 1 )==Date( j , 2 ) & base_date( : , 2 )==Date( j , 3 );
%         ltm_day = LTM( Cxa , : );
%         Data( j , vv ) = ltm_day( 1 , vv );
%     end
%     
% end
%% Converting Data 2 ZScores....
if Calendar==1; column_year = 1; column_month = 2;  column_day = 3; end;
if Calendar==0; column_year = 4; column_month = 5;  column_day = 6; end;
Tank_Zscore = [];
parfor i = 1:size(Date , 1);
%     disp(i);
    date = Date( i , : );
    Cx = find(base_date( : , 1)==date( 1 , column_month ) & base_date( : , 2)==date( 1 , column_day));
    xi = Data( i , : );
    xbar_data = LTM_Data( Cx , : );
    xbar_std = LTM_STD( Cx , : );
    Z = (( xi - xbar_data)./xbar_std);
    Tank_Zscore( i , : ) = Z;
end
    Z_Scores = Tank_Zscore;
    Base_Date = base_date;
    Observation = Obs;
end

