function  [ date_box , Scores , distance_box ] = Quality_Control_To_Ensure_Station_Temperature_Data_97_12_02 ( Threshold , Searching_radius , N , temperature_type , Input_Path )
%% Quality Control....
cd(Input_Path);
if strcmp(temperature_type , 'min' );
    load('Refined_Temperature_Data_98_09_04.mat')
    %     load('Standard_Scores_Min_Temp_97_12_16.mat');
    Temp = tmin;
elseif strcmp(temperature_type , 'max' );
    load('Refined_Temperature_Data_98_09_04.mat')
    
    Temp = tmax;
else
    return
end

cd('E:\University_Funded_Project_97_11_10\My_Developed_M_Files_Isfahan_Funded_Project_97_11_20');

Calendar = 1;        % It Means Solar Persian Calendar .....
% Calendar = 0;   % It Means Grogrian Calendar .....

[ Z_Scores , LTM_Data , LTM_STD , Base_Date , Observation] = Computing_Standard_Scores_97_12_09( Temp , Date , Calendar );
disp('Passed...')
Data = Z_Scores; 
Pos = pos;
if sign(Threshold)==1;  [ day , station ] = find(Data>=Threshold); end;
if sign(Threshold)==-1; [ day , station ] = find(Data<=Threshold); end;
date_box = []; Distance_Box = [];
for j = 1:length(day);
    posr = Pos( station(j) , : );
    Dis = distance( Pos( : , 2 ) , Pos( : , 1) , posr(2) , posr(1));
    dis = Dis;
    Distance_Box{j} = dis;
    Dis(Dis==0) = nan;
    Cola = find(Dis<=Searching_radius);
    Colb = find(dis<=Searching_radius);
    Clsa = Data( day(j) , Cola ); % Excluding the target station....
    Clsb = Data( day(j) , Colb ); % Including the target station....
    
    abs_diff = sqrt( ([ min(Clsb) - max(Clsb) ])^2);
    sub_date = Date(day(j) , 1:6 );
    vx = find(Base_Date( : , 1 )==sub_date( 1 , 2 ) & Base_Date( : , 2 )==sub_date( 1 , 3 ));
    num_ltm = Observation( vx , station(j) );
   
    date_box( j , : ) =  [ Date(day(j) , 1:6 ) , day(j) , Data( day(j) , station(j) ) , Temp( day(j) , station(j) ) ,  station(j) ,  sum(~isnan(Clsa)) , nanmean(Clsa) , ...
        abs_diff , min(Clsb) , max(Clsb) , num_ltm  ];
    
    a = find(Clsa==max(Clsa));
    b = find(Clsb==max(Clsb));
    if isempty(a); a = nan; end;
    if isempty(b); b = nan; end;
    Index( j , : ) = [ a(1) , b(1)  ];
    Ca{j} = Clsa;
    Cb{j} = Clsb;
   
end

% if sign(Threshold)==1;  File_Name = 'Extreme_Hot_Station_Distances';   end;
% if sign(Threshold)==-1; File_Name = 'Extreme_Cold_Station_Distances'; end;
% %
% save([ File_Name int2str(N) '.mat' ] , 'Distance_Box' );
distance_box = Distance_Box;
Scores = Z_Scores;
end

