function  [ date_box ] = Quality_Control_To_Ensure_Station_Temperature_Data_97_12_02 ( Threshold , Searching_radius , N , temperature_type )
%% Quality Control....

Data = Z_Scores; 
Pos = pos;
if sign(Threshold)==1;  [ day , station ] = find(Data>=Threshold); end;
if sign(Threshold)==-1; [ day , station ] = find(Data<=Threshold); end;
date_box = []; Distance_Box = [];
for j = 1:length(day);
    posr = Pos( station(j) , : );
    Dis = distance( Pos( : , 2 ) , Pos( : , 1) , posr(2) , posr(1));
    dis = Dis;
    Distance_Box{j} = dis;
    Dis(Dis==0) = nan;
    Cola = find(Dis<=Searching_radius);
    Colb = find(dis<=Searching_radius);
    Clsa = Data( day(j) , Cola ); % Excluding the target station....
    Clsb = Data( day(j) , Colb ); % Including the target station....
    
    abs_diff = sqrt( ([ min(Clsb) - max(Clsb) ])^2);
    sub_date = Date(day(j) , 1:6 );
    vx = find(Base_Date( : , 1 )==sub_date( 1 , 2 ) & Base_Date( : , 2 )==sub_date( 1 , 3 ));
    num_ltm = Observation( vx , station(j) );
   
    date_box( j , : ) =  [ Date(day(j) , 1:6 ) , day(j) , Data( day(j) , station(j) ) , Temp( day(j) , station(j) ) ,  station(j) ,  sum(~isnan(Clsa)) , nanmean(Clsa) , ...
        abs_diff , min(Clsb) , max(Clsb) , num_ltm  ];
    
    a = find(Clsa==max(Clsa));
    b = find(Clsb==max(Clsb));
    if isempty(a); a = nan; end;
    if isempty(b); b = nan; end;
    Index( j , : ) = [ a(1) , b(1)  ];
    Ca{j} = Clsa;
    Cb{j} = Clsb;
   
end

if sign(Threshold)==1;  File_Name = 'Extreme_Hot_Temperature_Records_0';   end;
if sign(Threshold)==-1; File_Name = 'Extreme_Cold_Temperature_Records_0'; end;

save([ File_Name int2str(N) '.mat' ] , 'Distance_Box' );

end

